package com.jproxy.samples.corba.test;

import java.util.*;
import javax.naming.*;

/*
The samples shows how to communicate with CORBA over JProxy.
It uses JNDI CORBA Naming SPI for remote object navigation.
Notice that no one CORBA API class is used.
It means that CORBA may not be present at all on client-side!

Here is a reference for COS Naming Service Provider for the Java Naming and Directory InterfaceTM (JNDI):
http://www.iona.com/devcenter/appserv/apis/jdk1.3/docs/guide/jndi/jndi-cos.html

Here is a tutorial explaining how to write a CORBA server and client:
http://java.sun.com/docs/books/tutorial/idl/hello/index.html
*/
public class TestClient
{
	public static void main(String args[])
	{
		try{
			// Hashtable env = System.getProperties();
			// the property "com.jproxy.proxy.initial" may be specified in proxy.properties or inline here:
			// env.put(com.jproxy.proxy.Tunnel.INITIAL_CONTEXT_FACTORY , "com.sun.jndi.cosnaming.CNCtxFactory");

			// env.put(Context.INITIAL_CONTEXT_FACTORY, "com.jproxy.proxy.NamingContextFactory");
			// env.put(Context.PROVIDER_URL, "http://localhost:8080");

			Context context = new InitialContext();

			Test test = (Test)context.lookup("test");

			System.out.println(
				"\r\n**********************************"+
				"\r\nJProxy-CORBA Test CLIENT"+
				"\r\nServer Time: "+(new Date(test.getServerTime()))+
				"\r\n**********************************\r\n");
		}
		catch(Exception e) {
			System.out.println("ERROR : " + e);
			e.printStackTrace(System.out);
		}
	}
}
