package com.jproxy.samples.corba.test;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;

import java.util.*;

public class TestServer
{

	public static void main(String args[])
	{
		try{
			// create and initialize the ORB
			ORB orb = ORB.init(args, null);

			// Create the servant and register it with the ORB
			TestImpl impl = new TestImpl();
			orb.connect(impl);

			// Get the root naming context
			org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
			NamingContext ncRef = NamingContextHelper.narrow(objRef);

			// Bind the object reference in naming
			NameComponent nc = new NameComponent("test", "");
			NameComponent path[] = {nc};
			ncRef.rebind(path, impl);

			System.out.println(
				"\r\n**********************************"+
				"\r\nCORBA Test "+
				"\r\nServer Time: "+(new Date(impl.getServerTime()))+
				"\r\nServer started. "+
				"\r\n**********************************\r\n");

			// Wait for invocations from clients
			String sync = "";
			synchronized(sync){
				sync.wait();
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
}