package com.jproxy.mlist.applet;

import java.io.*;
import java.util.*;
import java.net.*;

public class AppletHelper
{
	static public String getHostName()
		throws UnknownHostException
	{
		String res = "";
		InetAddress ia = InetAddress.getLocalHost();
		res = ia.getHostName();
		return res;
	}

	static public String getHostIPAddress()
		throws UnknownHostException
	{
		String res = "";
		InetAddress ia = InetAddress.getLocalHost();
		res = ia.getHostAddress();
		return res;
	}

	static LogTimer timer = new LogTimer();
	long time = System.currentTimeMillis();
	public void printLogStart(String str)
	{
		timer.start();
		System.out.println("\n"+str+" : ... ");
	}
	public void printLogStop(String str, Object o)
	{
		timer.stop();
		String s = "   "+timer;
		if(str!=null)
			s += " res = "+str;
		if(o!=null)
			s += " objectSize = "+getObjectSize(o);
		System.out.println(s);
	}

	static public int getObjectSize(Object o)
	{
		int res = -1;
		try
		{
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			ObjectOutputStream oos = new ObjectOutputStream(baos);
			oos.writeObject(o);
			oos.flush();
			res = baos.size();
		}
		catch (IOException e){e.printStackTrace();}
		return res;
	}
}

class LogTimer
{
	public long time = System.currentTimeMillis();
	public String title = "";

	public LogTimer()
	{
	}

	public void start()
	{
		time = System.currentTimeMillis();
	}

	public void stop()
	{
		time = System.currentTimeMillis() - time;
	}

	public String toString()
	{
		return title+" time="+getTime(time);
	}

	static String getPeriod(long time)
	{
		return getTime(System.currentTimeMillis() - time);
	}

	static String getZeros(long v)
	{
		return (v < 10)? "0"+v : ""+v;
	}

	static public String getTime(long time)
	{
		long ms = time % 1000;
		time /= 1000;
		long s = time % 60;
		time /= 60;
		long m = time % 60;
		long h = time / 60;
		String ss = "";

		if(h>0)
			ss += getZeros(h)+"h:";
		if(h>0 || m>0)
			ss += getZeros(m)+"m:";
		if(h>0 || m>0 || s>0)
			ss += getZeros(s)+"s";

		if(h==0 && m==0 && s < 9)
		{
			if(s>0)
				ss += ":";
			ss += ms+"ms";
		}
		return ss;
	}
}
