package com.jproxy.mlist.applet.jmsclock;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.jms.*;

import com.jproxy.mlist.applet.*;
import com.jproxy.mlist.ejbeans.interfaces.*;

public class JMSClockApplet
	extends Applet
{
	String[] args = null;
	String sessionID = "";

	/** JNDI initial context */
	InitialContext context = null;
	Hashtable env = new Hashtable();
	/** The JMS TopicConnectionFactory for recieving messages from App Server */
	TopicConnectionFactory connectionFactory = null;
	/** The JMS TopicConnection */
	TopicConnection connection = null;
	/** The JMS Topic */
	Topic topic = null;

	TopicSession session = null;
	TopicSubscriber subscriber = null;

	//Construct the applet
	public JMSClockApplet()
	{
		super();
	}

	public void start()
	{
		if(connection!=null)
			return;
		sessionID = getParameter("session-id");
		setLayout(new BorderLayout());
		initJms();
		initComponents();
	}

	public void stop()
	{
		if(connection==null)
			return;
		try{
			connection.close();
		}
		catch(JMSException e){}
		connection = null;
	}

	public void initJms()
	{
		try
		{
			String hostUrl = getCodeBase().getHost();
			if(getCodeBase().getPort()!=-1)
				hostUrl += ":"+getCodeBase().getPort();

			env.put(Context.PROVIDER_URL, hostUrl);
			env.put(Context.INITIAL_CONTEXT_FACTORY, "com.jproxy.proxy.NamingContextFactory");

			context = new InitialContext(env);

			System.out.println("context.lookup(\"ConnectionFactory\");");
			TopicConnectionFactory connectionFactory =
				(TopicConnectionFactory)context.lookup("ConnectionFactory");

			System.out.println("connectionFactory.createTopicConnection();");
			connection = connectionFactory.createTopicConnection();

			System.out.println("context.lookup(\"topic/testTopic\");");
			topic = (Topic)context.lookup("topic/testTopic");

			System.out.println("connection.createTopicSession(false, javax.jms.Session.DUPS_OK_ACKNOWLEDGE);");
			session = connection.createTopicSession(false, javax.jms.Session.DUPS_OK_ACKNOWLEDGE);

			System.out.println("session.createSubscriber("+topic+");");
			subscriber = session.createSubscriber(topic);

			TopicMessageListener tm = new TopicMessageListener(this);
			System.out.println("subscriber.setMessageListener("+tm+");");
			subscriber.setMessageListener(tm);
			connection.start();
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}


	/** The method is called from TopicMessageListener */
	public void setTime(String time)
	{
		clock.setText(time);
	}

	/** The GUI support */
	public Label clock = new Label("");

	void initComponents()
	{
		setBackground(Color.white);
		setLayout(null);

		Font font = new Font("Arial", Font.BOLD, 20);
		String fontName = font.getName();
		font = new Font(fontName, Font.PLAIN, 14);

		int remX = 80; int remY = 150;
		Label rem1 = new Label("This is JMSClockApplet example.");
		rem1.setFont(font);
		rem1.setBounds(remX, remY, 550, 20);
		add(rem1);

		clock.setFont(new Font(fontName, Font.BOLD, 30));
		clock.setForeground(Color.blue);
		clock.setBounds(100, remY+50, 600, 30);
		add(clock);

		doLayout();
		repaint();
		invalidate();
	}

	Image img = null;
	boolean painted = false;
	public void paint(Graphics g)
	{
		super.paint(g);
		if(img==null)
			img = getImage(getCodeBase(),"resources/jproxy.gif");
		if(img!=null)
			g.drawImage(img, 0, 0, this);
	}
}
