package com.jproxy.mlist.applet.jmsmessanger;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;

import com.jproxy.mlist.applet. *;
import com.jproxy.mlist.ejbeans.interfaces.*;

public class JMSMessangerApplet
	extends Applet
{
	String[] args = null;
	Hashtable env = new Hashtable();

	InitialContext context = null;
	TopicConnectionFactory connectionFactory = null;
	TopicConnection connection = null;
	Topic topic = null;
	TopicSession topicSession = null;
	TopicPublisher publisher = null;
	TopicSubscriber subscriber = null;
	MapMessage msg = null;

	String subject = null;
	String filter = null;

	//Construct the applet
	public JMSMessangerApplet()
	{
		super();
	}

	public void start()
	{
		if(connection!=null)
			return;
		setLayout(new BorderLayout());
		initJms();
		initComponents();
	}

	public void stop()
	{
		if(connection==null)
			return;
		try{
			connection.close();
		}
		catch(JMSException e){}
		connection = null;
	}

	public void initJms()
	{
		try
		{
			/**
			 * Default Provider URL may be specified in proxy.properties
			 * Or this URL be used
			 * hostUrl = "http://"+host+"/proxyservlet/servlet/proxyservlet";
			 * Or this one if SSL supported:
			 * hostUrl = "https://"+host;
			 */
			String hostUrl = getCodeBase().getHost();
			if(getCodeBase().getPort()!=-1)
				hostUrl += ":"+getCodeBase().getPort();

			env.put(Context.PROVIDER_URL, hostUrl);
			env.put(Context.INITIAL_CONTEXT_FACTORY, "com.jproxy.proxy.NamingContextFactory");

			System.out.println("new InitialContext(env);");
			context = new InitialContext(env);

			System.out.println("TopicConnectionFactory connectionFactory = "+
				"(TopicConnectionFactory)context.lookup(\"ConnectionFactory\");");
			TopicConnectionFactory connectionFactory = (TopicConnectionFactory)context.lookup("ConnectionFactory");

			System.out.println("connection = connectionFactory.createTopicConnection();");
			connection = connectionFactory.createTopicConnection();

			System.out.println("topic = (Topic)context.lookup(\"topic/testTopic\");");
			topic = (Topic)context.lookup("topic/testTopic");

			System.out.println("session = connection.createTopicSession(false, "+
				javax.jms.Session.DUPS_OK_ACKNOWLEDGE+");");
			topicSession = connection.createTopicSession(false, javax.jms.Session.DUPS_OK_ACKNOWLEDGE);

			System.out.println("session.createMessage();");
			msg = topicSession.createMapMessage();
			msg.setJMSExpiration(System.currentTimeMillis()+30*1000);

			System.out.println("publisher = session.createPublisher("+topic+");");
			publisher = topicSession.createPublisher(topic);

			buttonSend.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					try
					{
						sendMessage(textMessage.getText());
						textMessage.setText("");
					}catch(Exception ee){ee.printStackTrace();}
				}
			});
		}
		catch (Exception e){e.printStackTrace();}
	}


	void sendMessage(String str)
		throws Exception
	{
		String filter1 = textFilter.getText().trim();
		if(filter1.length()==0)
		{
			messagesLog.setText("Warning: \"Filter\"-field to be set.\r\n"+messagesLog.getText());
			return;
		}
		if(str.trim().length()==0)
			return;

		if(!filter1.equals(filter) || subscriber==null)
		{
			filter = filter1;
			if(subscriber!=null)
				subscriber.close();
			String selector = "filter LIKE '"+filter+"'";
			System.out.println("session.createSubscriber("+topic+", "+selector+", false);");
			subscriber = topicSession.createSubscriber(topic, selector, false);
			FilterMessageListener fml = new FilterMessageListener(this);
			System.out.println("ts.setMessageListener("+fml+");");
			subscriber.setMessageListener(fml);

			System.out.println("connection.start();");
			connection.start();
		}
		String subject = textSubject.getText().trim();
		if(subject.length()==0)
		{
			subject = "GUEST";
			textSubject.setText(subject);
		}
		str = filter+" : "+subject+" : "+str;

		msg.setStringProperty("filter", filter);
		msg.setStringProperty("content", str);

//		ObjectMessage msg = topicSession.createObjectMessage(filter+" : "+str);


		System.out.println("publisher.publish();");
		publisher.publish(msg);
	}

	TextArea messagesLog = new TextArea("", 5, 5, TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextField textSubject = new TextField();
	TextField textFilter = new TextField();
	TextField textMessage = new TextField();
	Button buttonSend = new Button("Send Message");

	/** The GUI support */
	void initComponents()
	{
		setBackground(Color.white);
		setLayout(null);

		Font font = new Font("Arial", Font.BOLD, 20);
		String fontName = font.getName();
		int fontStyle = font.getStyle();
		font = new Font(fontName, Font.PLAIN, 14);

		int remX = 80; int remY = 150;

		Label rem1 = new Label("This is JMSMessangerApplet example.");
		rem1.setFont(font);
		rem1.setBounds(remX, remY, 550, 20);
		add(rem1);
		remY += 20;
		Label rem2 = new Label("You can send message to other computer using JMS filter.");
		rem2.setFont(font);
		rem2.setBounds(remX, remY, 550, 20);
		add(rem2);
		remY += 20;
		Label rem3 = new Label("Just run two JMSMessangerApplet applications.");
		rem3.setFont(font);
		rem3.setBounds(remX, remY, 550, 20);
		add(rem3);
		remY += 20;
		Label rem4 = new Label("You have to type same filter value, and send message pressing Send button.");
		rem4.setFont(font);
		rem4.setBounds(remX, remY, 550, 20);
		add(rem4);
		remY += 20;
		Label rem5 = new Label("The Http tunnel allows send this message throw all kind firewalls.");
		rem5.setFont(font);
		rem5.setBounds(remX, remY, 550, 20);
		add(rem5);
		remY += 20;
		remY += 20;
		Label rem6 = new Label("The log information you can see in Java console.");
		rem6.setFont(font);
		rem6.setBounds(remX, remY, 550, 20);
		add(rem6);

		remY += 40;
		Label remMessagesLog = new Label("Messages List:");
		remMessagesLog.setFont(font);
		remMessagesLog.setBounds(remX, remY, 550, 20);
		add(remMessagesLog);
		remY += 20;
		messagesLog.setEditable(false);
		messagesLog.setBounds(remX, remY, 550, 100);
		add(messagesLog);

		remY += 100;
		Label remFilter = new Label("Filter:");
		remFilter.setFont(font);
		remFilter.setBounds(remX, remY, 350, 20);
		add(remFilter);
		remY += 20;
		textFilter.setBounds(remX, remY, 350, 20);
		textFilter.setText("");
		add(textFilter);

		remY += 20;
		Label remSubject = new Label("Please type your nickname:");
		remSubject.setFont(font);
		remSubject.setBounds(remX, remY, 350, 20);
		add(remSubject);
		remY += 20;
		textSubject.setBounds(remX, remY, 350, 20);
		textSubject.setText("GUEST");
		add(textSubject);

		remY += 20;
		Label remMessage = new Label("Message:");
		remMessage.setFont(font);
		remMessage.setBounds(remX, remY, 350, 20);
		add(remMessage);
		remY += 20;
		textMessage.setBounds(remX, remY, 350, 20);
		textMessage.setText("");
		add(textMessage);

		buttonSend.setBounds(remX+400, remY-20, 150, 30);
		add(buttonSend);

		doLayout();
		repaint();
		invalidate();
	}

	Image img = null;
	boolean painted = false;
	public void paint(Graphics g)
	{
		super.paint(g);
		if(img==null)
			img = getImage(getCodeBase(),"resources/jproxy.gif");
		if(img!=null)
			g.drawImage(img, 0, 0, this);
	}
}
