package com.jproxy.mlist.mbeans;

import java.lang.reflect.*;

import javax.management.*;

public class JMXInvocator
	implements InvocationHandler,
			   java.io.Serializable
{
	MBeanServer server;
	Class objectClass;
	String objectName;

	private JMXInvocator(MBeanServer _server, Class _objectClass, String _objectName)
	{
		server = _server;
		objectClass = _objectClass;
		objectName = _objectName;
	}

	static public Object createProxy(MBeanServer server, Class objectClass, String objectName)
		throws Exception
	{
		JMXInvocator invocator = new JMXInvocator(server, objectClass, objectName);
		Class[] proxyInterfaces = new Class[] { objectClass };
		Class proxyClass = Proxy.getProxyClass(objectClass.getClassLoader(), proxyInterfaces);

		Object proxy = null;
//		try{
			Constructor con = proxyClass.getConstructor(new Class[] { InvocationHandler.class });
			Object[] os = {invocator};
			proxy = (Proxy)con.newInstance(os);
//		}
//		catch(Exception e){
//		}
		return proxy;
	}

	public Object invoke(Object proxy, Method method, Object[] args)
		throws Throwable
	{
		Class[] cl = method.getParameterTypes();
		String[] classNames = new String[cl.length];
		for(int i=0; i<cl.length; i++)
			classNames[i] = cl[i].getName();
		Object res = server.invoke(new ObjectName(objectName), method.getName(), args, classNames);
		return res;
	}

	static public Object getMBean(String mbean, Class interfaceClass)
		throws Exception
	{
		Object res = null;
		java.util.ArrayList al = MBeanServerFactory.findMBeanServer(null);

		ObjectInstance oi = null;
		MBeanServer mbs = null;
		for(int i=0; i<al.size(); i++)
		{
			try
			{
				mbs = (MBeanServer)al.get(i);
				ObjectName name = new ObjectName(mbean);
				oi = mbs.getObjectInstance(name);
				if(oi!=null)
					break;
			}
			catch (Exception e){}
		}
		res = JMXInvocator.createProxy(
			mbs,
			interfaceClass,
			oi.getObjectName().getCanonicalName());
		return res;
	}
}
