package com.jproxy.mlist.mbeans.tunneltimer;

import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.jms.*;

import javax.management.*;
import javax.management.timer.*;

import com.jproxy.proxy.callback.*;
import com.jproxy.proxy.*;

import com.jproxy.mlist.common.Res;

class TimerListener
	implements NotificationListener
{
	protected boolean isJMSInitialized = false;

	public TimerListener()
	{
		System.out.println("Invoke The TimerListener constructor");
	}

	public void handleNotification(
		Notification pNotification, Object pHandback)
	{
		if(!isJMSInitialized)
		{
			try{
				initJMS();
				isJMSInitialized = true;
			}
			catch(Exception e){}
		}
		else
		{
			try
			{
				sendMessage();
			}
			catch(Exception e){}
		}
	}

	Hashtable env = new Hashtable();

	/** JNDI initial context */
	protected InitialContext context = null;
	/** The JMS TopicConnectionFactory for recieving messages from App Server */
	protected TopicConnectionFactory connectionFactory = null;
	/** The JMS TopicConnection */
	protected TopicConnection connection = null;
	/** The JMS Topic */
	protected Topic topic = null;

	TopicSession session = null;
	TopicPublisher publisher = null;

	protected void initJMS()
		throws Exception
	{
		env.put(Context.INITIAL_CONTEXT_FACTORY,
			"org.jnp.interfaces.NamingContextFactory");
		env.put(Context.PROVIDER_URL, Res.hostName);

		context = new InitialContext(env);
		System.out.println("context className:"+context.getClass().getName());

		TopicConnectionFactory tcf =
			(TopicConnectionFactory)context.lookup("ConnectionFactory");

		connection = tcf.createTopicConnection();
		System.out.println("connection className : "+connection.getClass().getName());

		topic = (Topic)context.lookup("topic/testTopic");
		System.out.println("topic className:"+topic.getClass().getName());

		session = connection.createTopicSession(false, javax.jms.Session.DUPS_OK_ACKNOWLEDGE);
		System.out.println("session className:"+session.getClass().getName());

		publisher = session.createPublisher(topic);
	}

	private void sendMessage()
		throws Exception
	{
		String time = ""+(new Date(System.currentTimeMillis()));

		ObjectMessage message = session.createObjectMessage();
		message.setObject(time);

		message.setJMSExpiration(System.currentTimeMillis()+10*1000);
		publisher.publish(message);
	}
}

