package com.jproxy.mlist.mbeans.tunneltimer;

import java.util.*;

import javax.management.*;
import javax.management.timer.*;

import com.jproxy.mlist.mbeans.JMXInvocator;
import com.jproxy.mlist.mbeans.FileProperties;
import com.jproxy.mlist.common.Res;

public class TunnelTimer
	implements TunnelTimerMBean
{
	FileProperties prop = new FileProperties(this, "jproxy.properties");

	public TunnelTimer()
	{
	}

	boolean started = false;

	public void start() throws Exception
	{
		started = true;
		createTimer();
		System.out.println("JProxy TunnelTimerMBean started.");
	}
	public void stop() throws Exception
	{
		started = false;
	}

	String tunnelTimerPeriod = "com.jproxy.site.example.tunnel.timer.period";
	public void setPeriod(long value)
	{
		prop.setProperty(tunnelTimerPeriod, ""+value);
		prop.store();
		setTime();
	}
	public long getPeriod()
	{
		long res = 0;
		String str = prop.getProperty(tunnelTimerPeriod);
		if(str.trim().length()>0)
			res = (new Long(str)).longValue();
		return res;
	}

	void setTime()
	{
		if(started)
		try
		{
			timer.stop();
			timer.removeAllNotifications();

			mbs.addNotificationListener(
				oi.getObjectName(),
				tl,
				null,
				null
				);

			timer.addNotification("", "", null,
				new Date(System.currentTimeMillis()), getPeriod());
			timer.start();
		}
		catch (Exception e){e.printStackTrace();}
	}

	TimerListener tl =null;
	javax.management.timer.TimerMBean timer = null;
	ObjectInstance oi = null;
	MBeanServer mbs = null;
	void createTimer()
	{
		if(started)
		try
		{
			mbs = MBeanServerFactory.createMBeanServer();

			ObjectName name = new ObjectName("DefaultDomain", "service", "timer");
			oi = mbs.createMBean("javax.management.timer.Timer", name);

			timer =
				(javax.management.timer.TimerMBean)JMXInvocator.createProxy(
				mbs,
				javax.management.timer.TimerMBean.class,
				oi.getObjectName().getCanonicalName());

			timer.start();

			Set mbeans = mbs.queryMBeans(name, null);
			if(mbeans.isEmpty())
				return;

			tl = new TimerListener();
			mbs.addNotificationListener(
				oi.getObjectName(),
				tl,
				null,
				null
				);

			timer.addNotification("", "", null,
				new Date(System.currentTimeMillis()), getPeriod());
		}
		catch (Exception e){e.printStackTrace();}
	}
}
